=== debian/changelog ===
libcec (7.1.1-2) unstable; urgency=medium

  * Rules-requires-root now defaults to no
  * Update debian/watch to v5
  * Populate debian/clean to allow double build (closes: #1049263)

 -- Barak A. Pearlmutter <bap@debian.org>  Sat, 31 Jan 2026 17:05:12 +0000

libcec (7.1.1-1) unstable; urgency=medium

  * New upstream version
  * Use secure URI in Homepage field.
  * Install now-generated static library
  * Include upstream changelog
  * Generate python package

 -- Barak A. Pearlmutter <bap@debian.org>  Sun, 10 Aug 2025 22:56:57 +0100
